/*
 * 16F88_linetrace_blink.X
 * ライントレースロボットの動作確認用LEDとシリアル通信のテスト用プログラム
 * 
 * File:   main.c
 * Author: Taichi
 *
 * Created on 2017/11/06, 14:54
 */


// CONFIG1
#pragma config FOSC = INTOSCIO  // Oscillator Selection bits (INTRC oscillator; port I/O function on both RA6/OSC2/CLKO pin and RA7/OSC1/CLKI pin)
#pragma config WDTE = OFF       // Watchdog Timer Enable bit (WDT disabled)
#pragma config PWRTE = OFF      // Power-up Timer Enable bit (PWRT disabled)
#pragma config MCLRE = ON       // RA5/MCLR/VPP Pin Function Select bit (RA5/MCLR/VPP pin function is MCLR)
#pragma config BOREN = ON       // Brown-out Reset Enable bit (BOR enabled)
#pragma config LVP = OFF        // Low-Voltage Programming Enable bit (RB3 is digital I/O, HV on MCLR must be used for programming)
#pragma config CPD = OFF        // Data EE Memory Code Protection bit (Code protection off)
#pragma config WRT = OFF        // Flash Program Memory Write Enable bits (Write protection off)
#pragma config CCPMX = RB3      // CCP1 Pin Selection bit (CCP1 function on RB3)
#pragma config CP = OFF         // Flash Program Memory Code Protection bit (Code protection off)

// CONFIG2
#pragma config FCMEN = OFF      // Fail-Safe Clock Monitor Enable bit (Fail-Safe Clock Monitor disabled)
#pragma config IESO = OFF       // Internal External Switchover bit (Internal External Switchover mode disabled)

#include <xc.h>
#include <stdio.h>
#include "uart.h"

#define _XTAL_FREQ 8000000      // 8MHz

#define LED1 RB0 // 赤LED Lowレベルドライブ 負論理
#define LED2 RB1 // 緑LED Lowレベルドライブ 負論理


void main(void) {
    
    OSCCON = 0b01110000;    // 内蔵クロックの周波数を8MHzに設定
 
    PORTA = 0x00;           // PORTAを初期化
    PORTB = 0x00;           // PORTBを初期化
    TRISA = 0b00001100;     // PORTAの入出力設定 RA2,3はSENSOR
    TRISB = 0b00000100;     // PORTBの入出力設定 RB2はRX
    ANSEL = 0b00000000;     // ADコンバータ無効化
    
    initUART();             // 調歩同期式シリアル通信設定
 
    while(1){               // 無限ループ
        LED1=1;    // LED1 OFF Lowレベルドライブのため負論理
        LED2=1;    // LED2 OFF
        __delay_ms(500);        // 500ms待つ
        LED1=0;    // LED1 ON
        LED2=0;    // LED2 ON
        __delay_ms(500);    
        printf("Hello World!\n");
    }
}
